function [dist] = LB_Keogh(U, L, S, Lnorm)
%Computes LB_Keogh on the constrained DTW distance between Q and S
%#eml

%% Init
[n,d] = size(S);
if(n ~= size(U,1) || n ~= size(L,1))
    dist = Inf;
    return;
end

%% Compute LB_Keogh
dist = 0;
for i = 1:n
    disti = zeros(d,1);
    % Loop over dimensions
    for j = 1:d
        if(S(i,d) > U(i,d))
            disti(j) = S(i,d) - U(i,d);
        elseif(S(i,d) < L(i,d))
            disti(j) = L(i,d) - S(i,d);
        end
    end
    dist = dist + sum(disti.^Lnorm);
end

end