function [Qnoisy] = addNoise(Q, perc)
%Add noise to queries by replacing perc values with random others

querylength = size(Q{1},1);
nreplace = floor(perc*querylength);

Qnoisy = Q;

all = cell2mat(Q);

for i = 1:length(Q)
    % Create random indices
    replace = unique(randi(querylength,nreplace,1));
    while(length(replace) < nreplace)
        replace = unique(randi(querylength,nreplace,1));
    end
    replacewith = randi(size(all,1),nreplace,1);
    
    % Replace values in the query
    query = Qnoisy{i};
    for j = 1:nreplace
        query(replace(j),:) = all(replacewith(j),:);
    end
    Qnoisy{i} = query;
end

end