function [bestscore, lb_pruned, nwindows, index] = matchCDTW(song, query, U, L, r)

songlength = size(song,1);
querylength = size(query,1);

bestscore = Inf;
index = 0;
lb_pruned = 0;
nwindows = (songlength-querylength+1);

for i = 1:nwindows
    S = song(i:(i+querylength-1),:);
    lb_score = LB_Keogh(U,L,S,1);
    if(lb_score < bestscore)
        score = CDTW(query,S,1,r);
        if(score<bestscore)
            bestscore = score;
            index = i;
        end
    else
        lb_pruned = lb_pruned + 1;
    end
end

end