function [Q] = produceQueries(Songname, querysongs, querylength)
%Produce queries with noise
% Songname    - cell array of song names
% querysongs  - song indices the queries should correspond to
% querylength - length of the queries to construct

nqueries = length(querysongs);
Q = cell(nqueries,1);

for i = 1:nqueries
    songpath = Songname{querysongs(i)};
    song = dlmread(songpath,' ');
    startindex = randi(size(song,1)-querylength+1);
    endindex = startindex + querylength - 1; 
    Q{i} = song(startindex:endindex,:);
end

end