% Run experiments PETRA 2010 (reconstruction March 25, 2013)
%% Clear workspace
clear;

%% Load queries
load queries.mat;

%% Compile code
emlmex -eg {Q{1}, Q{1}, 1.0} -N numerictype('double') DTW.m
emlmex -eg {Q{1}, Q{1}, 1.0, 5.0} -N numerictype('double') CDTW.m
emlmex -eg {Q{1}, Q{1}, Q{1}, 1.0} -N numerictype('double') LB_Keogh.m
emlmex -eg {Q{1}, repmat(Q{1},8,1), 1.0} -N numerictype('double') SPRING.m

%% Run experiments
nfiles = length(proper);
r = 5;

scoreCDTW05 = zeros(length(proper),nqueries);
scoreCDTW10 = zeros(length(proper),nqueries);
scoreCDTW15 = zeros(length(proper),nqueries);
scoreCDTW20 = zeros(length(proper),nqueries);
scoreCDTW25 = zeros(length(proper),nqueries);
scoreCDTW30 = zeros(length(proper),nqueries);
scoreDTW05 = zeros(length(proper),nqueries);
scoreDTW10 = zeros(length(proper),nqueries);
scoreDTW15 = zeros(length(proper),nqueries);
scoreDTW20 = zeros(length(proper),nqueries);
scoreDTW25 = zeros(length(proper),nqueries);
scoreDTW30 = zeros(length(proper),nqueries);
scoreSPRING05 = zeros(length(proper),nqueries);
scoreSPRING10 = zeros(length(proper),nqueries);
scoreSPRING15 = zeros(length(proper),nqueries);
scoreSPRING20 = zeros(length(proper),nqueries);
scoreSPRING25 = zeros(length(proper),nqueries);
scoreSPRING30 = zeros(length(proper),nqueries);

[U,L] = envelopes(Q, r);

parfor i = 1:nfiles
    songpath = ['../' Songnameproper{i}];
    song = dlmread(songpath,' ');
    songExt = vertcat(song, repmat(10000.0,400-size(song,1),2));
    scoreCDTW05i = zeros(1,nqueries);
    scoreCDTW10i = zeros(1,nqueries);
    scoreCDTW15i = zeros(1,nqueries);
    scoreCDTW20i = zeros(1,nqueries);
    scoreCDTW25i = zeros(1,nqueries);
    scoreCDTW30i = zeros(1,nqueries);
    scoreDTW05i = zeros(1,nqueries);
    scoreDTW10i = zeros(1,nqueries);
    scoreDTW15i = zeros(1,nqueries);
    scoreDTW20i = zeros(1,nqueries);
    scoreDTW25i = zeros(1,nqueries);
    scoreDTW30i = zeros(1,nqueries);
    scoreSPRING05i = zeros(1,nqueries);
    scoreSPRING10i = zeros(1,nqueries);
    scoreSPRING15i = zeros(1,nqueries);
    scoreSPRING20i = zeros(1,nqueries);
    scoreSPRING25i = zeros(1,nqueries);
    scoreSPRING30i = zeros(1,nqueries);
    for j = 1:nqueries
        scoreCDTW05i(j) = matchCDTW(song, Qnoisy05{j}, U{j}, L{j}, r); %#ok<*PFBNS>
        scoreCDTW10i(j) = matchCDTW(song, Qnoisy10{j}, U{j}, L{j}, r);
        scoreCDTW15i(j) = matchCDTW(song, Qnoisy15{j}, U{j}, L{j}, r);
        scoreCDTW20i(j) = matchCDTW(song, Qnoisy20{j}, U{j}, L{j}, r);
        scoreCDTW25i(j) = matchCDTW(song, Qnoisy25{j}, U{j}, L{j}, r);
        scoreCDTW30i(j) = matchCDTW(song, Qnoisy30{j}, U{j}, L{j}, r);
        scoreDTW05i(j) = matchDTW(song, Qnoisy05{j}); %#ok<*PFBNS>
        scoreDTW10i(j) = matchDTW(song, Qnoisy10{j});
        scoreDTW15i(j) = matchDTW(song, Qnoisy15{j});
        scoreDTW20i(j) = matchDTW(song, Qnoisy20{j});
        scoreDTW25i(j) = matchDTW(song, Qnoisy25{j});
        scoreDTW30i(j) = matchDTW(song, Qnoisy30{j});
        scoreSPRING05i(j) = matchSPRING(songExt, Qnoisy05{j}); %#ok<*PFBNS>
        scoreSPRING10i(j) = matchSPRING(songExt, Qnoisy10{j});
        scoreSPRING15i(j) = matchSPRING(songExt, Qnoisy15{j});
        scoreSPRING20i(j) = matchSPRING(songExt, Qnoisy20{j});
        scoreSPRING25i(j) = matchSPRING(songExt, Qnoisy25{j});
        scoreSPRING30i(j) = matchSPRING(songExt, Qnoisy30{j});
    end
    scoreCDTW05(i,:) = scoreCDTW05i;
    scoreCDTW10(i,:) = scoreCDTW10i;
    scoreCDTW15(i,:) = scoreCDTW15i;
    scoreCDTW20(i,:) = scoreCDTW20i;
    scoreCDTW25(i,:) = scoreCDTW25i;
    scoreCDTW30(i,:) = scoreCDTW30i;
    scoreDTW05(i,:) = scoreDTW05i;
    scoreDTW10(i,:) = scoreDTW10i;
    scoreDTW15(i,:) = scoreDTW15i;
    scoreDTW20(i,:) = scoreDTW20i;
    scoreDTW25(i,:) = scoreDTW25i;
    scoreDTW30(i,:) = scoreDTW30i;
    scoreSPRING05(i,:) = scoreSPRING05i;
    scoreSPRING10(i,:) = scoreSPRING10i;
    scoreSPRING15(i,:) = scoreSPRING15i;
    scoreSPRING20(i,:) = scoreSPRING20i;
    scoreSPRING25(i,:) = scoreSPRING25i;
    scoreSPRING30(i,:) = scoreSPRING30i;
end

clear nfiles i songpath song j;

save resultsAll.mat;

%% Load results
clear;
load resultsAll.mat;

%% Compute all ranks
querysongsproper = zeros(nqueries,1);
for i = 1:nqueries
    querysongsproper(i) = find(proper == querysongs(i));
end

[scoreCDTW05ranked, CDTW05ranked] = sort(scoreCDTW05);
[scoreCDTW10ranked, CDTW10ranked] = sort(scoreCDTW10);
[scoreCDTW15ranked, CDTW15ranked] = sort(scoreCDTW15);
[scoreCDTW20ranked, CDTW20ranked] = sort(scoreCDTW20);
[scoreCDTW25ranked, CDTW25ranked] = sort(scoreCDTW25);
[scoreCDTW30ranked, CDTW30ranked] = sort(scoreCDTW30);
[scoreDTW05ranked, DTW05ranked] = sort(scoreDTW05);
[scoreDTW10ranked, DTW10ranked] = sort(scoreDTW10);
[scoreDTW15ranked, DTW15ranked] = sort(scoreDTW15);
[scoreDTW20ranked, DTW20ranked] = sort(scoreDTW20);
[scoreDTW25ranked, DTW25ranked] = sort(scoreDTW25);
[scoreDTW30ranked, DTW30ranked] = sort(scoreDTW30);
[scoreSPRING05ranked, SPRING05ranked] = sort(scoreSPRING05);
[scoreSPRING10ranked, SPRING10ranked] = sort(scoreSPRING10);
[scoreSPRING15ranked, SPRING15ranked] = sort(scoreSPRING15);
[scoreSPRING20ranked, SPRING20ranked] = sort(scoreSPRING20);
[scoreSPRING25ranked, SPRING25ranked] = sort(scoreSPRING25);
[scoreSPRING30ranked, SPRING30ranked] = sort(scoreSPRING30);
CDTW05rank = zeros(50,1);
CDTW10rank = zeros(50,1);
CDTW15rank = zeros(50,1);
CDTW20rank = zeros(50,1);
CDTW25rank = zeros(50,1);
CDTW30rank = zeros(50,1);
DTW05rank = zeros(50,1);
DTW10rank = zeros(50,1);
DTW15rank = zeros(50,1);
DTW20rank = zeros(50,1);
DTW25rank = zeros(50,1);
DTW30rank = zeros(50,1);
SPRING05rank = zeros(50,1);
SPRING10rank = zeros(50,1);
SPRING15rank = zeros(50,1);
SPRING20rank = zeros(50,1);
SPRING25rank = zeros(50,1);
SPRING30rank = zeros(50,1);
for i = 1:nqueries
    CDTW05rank(i) = find(CDTW05ranked(:,i) == querysongsproper(i));
    CDTW10rank(i) = find(CDTW10ranked(:,i) == querysongsproper(i));
    CDTW15rank(i) = find(CDTW15ranked(:,i) == querysongsproper(i));
    CDTW20rank(i) = find(CDTW20ranked(:,i) == querysongsproper(i));
    CDTW25rank(i) = find(CDTW25ranked(:,i) == querysongsproper(i));
    CDTW30rank(i) = find(CDTW30ranked(:,i) == querysongsproper(i));
    DTW05rank(i) = find(DTW05ranked(:,i) == querysongsproper(i));
    DTW10rank(i) = find(DTW10ranked(:,i) == querysongsproper(i));
    DTW15rank(i) = find(DTW15ranked(:,i) == querysongsproper(i));
    DTW20rank(i) = find(DTW20ranked(:,i) == querysongsproper(i));
    DTW25rank(i) = find(DTW25ranked(:,i) == querysongsproper(i));
    DTW30rank(i) = find(DTW30ranked(:,i) == querysongsproper(i));
    SPRING05rank(i) = find(SPRING05ranked(:,i) == querysongsproper(i));
    SPRING10rank(i) = find(SPRING10ranked(:,i) == querysongsproper(i));
    SPRING15rank(i) = find(SPRING15ranked(:,i) == querysongsproper(i));
    SPRING20rank(i) = find(SPRING20ranked(:,i) == querysongsproper(i));
    SPRING25rank(i) = find(SPRING25ranked(:,i) == querysongsproper(i));
    SPRING30rank(i) = find(SPRING30ranked(:,i) == querysongsproper(i));
end
CDTW05rank = sort(CDTW05rank);
CDTW10rank = sort(CDTW10rank);
CDTW15rank = sort(CDTW15rank);
CDTW20rank = sort(CDTW20rank);
CDTW25rank = sort(CDTW25rank);
CDTW30rank = sort(CDTW30rank);
DTW05rank = sort(DTW05rank);
DTW10rank = sort(DTW10rank);
DTW15rank = sort(DTW15rank);
DTW20rank = sort(DTW20rank);
DTW25rank = sort(DTW25rank);
DTW30rank = sort(DTW30rank);
SPRING05rank = sort(SPRING05rank);
SPRING10rank = sort(SPRING10rank);
SPRING15rank = sort(SPRING15rank);
SPRING20rank = sort(SPRING20rank);
SPRING25rank = sort(SPRING25rank);
SPRING30rank = sort(SPRING30rank);

CDTW05rankperc = CDTW05rank ./ 10749 * 100;
CDTW10rankperc = CDTW10rank ./ 10749 * 100;
CDTW15rankperc = CDTW15rank ./ 10749 * 100;
CDTW20rankperc = CDTW20rank ./ 10749 * 100;
CDTW25rankperc = CDTW25rank ./ 10749 * 100;
CDTW30rankperc = CDTW30rank ./ 10749 * 100;
DTW05rankperc = DTW05rank ./ 10749 * 100;
DTW10rankperc = DTW10rank ./ 10749 * 100;
DTW15rankperc = DTW15rank ./ 10749 * 100;
DTW20rankperc = DTW20rank ./ 10749 * 100;
DTW25rankperc = DTW25rank ./ 10749 * 100;
DTW30rankperc = DTW30rank ./ 10749 * 100;
SPRING05rankperc = SPRING05rank ./ 10749 * 100;
SPRING10rankperc = SPRING10rank ./ 10749 * 100;
SPRING15rankperc = SPRING15rank ./ 10749 * 100;
SPRING20rankperc = SPRING20rank ./ 10749 * 100;
SPRING25rankperc = SPRING25rank ./ 10749 * 100;
SPRING30rankperc = SPRING30rank ./ 10749 * 100;

clear querysongsproper i;

%% Plot figure 1
maxrankperc = 50*100/10749;
minqueryperc = 50;
Y = (1:nqueries)*100/nqueries;

%Plot figure for each noise level
subplot(2,3,1);
hold on;
plot(CDTW05rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW05rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING05rankperc,Y,'r-','LineWidth',2.0);
title('5 % Noise');
xlabel('Rank');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,2);
hold on;
plot(CDTW10rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW10rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING10rankperc,Y,'r-','LineWidth',2.0);
title('10 % Noise');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
xlabel('Rank');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,3);
hold on;
plot(CDTW15rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW15rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING15rankperc,Y,'r-','LineWidth',2.0);
title('15 % Noise');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
xlabel('Rank');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,4);
hold on;
plot(CDTW20rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW20rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING20rankperc,Y,'r-','LineWidth',2.0);
title('20 % Noise');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
xlabel('Rank');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,5);
hold on;
plot(CDTW25rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW25rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING25rankperc,Y,'r-','LineWidth',2.0);
title('25 % Noise');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
xlabel('Rank');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,6);
hold on;
plot(CDTW30rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW30rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING30rankperc,Y,'r-','LineWidth',2.0);
title('30 % Noise');
set(gca,'XTick',[10/10749 20/10749 30/10749 40/10749 50/10749]*100);
set(gca,'XTickLabel',{'10','20','30','40','50'});
xlabel('Rank');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

legend({'CDTW','DTW','SPRING'});

%% Plot figure 2
maxrankperc = 100;
minqueryperc = 50;

%Plot figure for each noise level
subplot(2,3,1);
hold on;
plot(CDTW05rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW05rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING05rankperc,Y,'r-','LineWidth',2.0);
title('5 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,2);
hold on;
plot(CDTW10rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW10rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING10rankperc,Y,'r-','LineWidth',2.0);
title('10 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,3);
hold on;
plot(CDTW15rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW15rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING15rankperc,Y,'r-','LineWidth',2.0);
title('15 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,4);
hold on;
plot(CDTW20rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW20rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING20rankperc,Y,'r-','LineWidth',2.0);
title('20 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,5);
hold on;
plot(CDTW25rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW25rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING25rankperc,Y,'r-','LineWidth',2.0);
title('25 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

subplot(2,3,6);
hold on;
plot(CDTW30rankperc,Y,'g-.','LineWidth',2.0);
plot(DTW30rankperc,Y,'b--','LineWidth',2.0);
plot(SPRING30rankperc,Y,'r-','LineWidth',2.0);
title('30 % Noise');
xlabel('Rank %');
ylabel('Query %');
xlim([(100/10749) maxrankperc]);
ylim([minqueryperc 100]);
hold off;

legend({'CDTW','DTW','SPRING'});